#include <windows.h>
#include <stdio.h>
#include "midiplay.h"


void RegisterSongType(HWND hwnd, char *name, int iconnum)
{
  DWORD EmptyData;

  HKEY TypeKey;
  if (RegCreateKeyEx(HKEY_CLASSES_ROOT, name, 0, "", REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &TypeKey, &EmptyData) == ERROR_SUCCESS)
  {
    if (RegSetValueEx(TypeKey, "", 0, REG_SZ, (BYTE *)"MIDI Sequence", strlen("MIDI Sequence") + 1) != ERROR_SUCCESS)
      MessageBox(hwnd, "Error: Could not set registry data", AppName, MB_OK);

    HKEY IconKey;
    if (RegCreateKeyEx(TypeKey, "DefaultIcon", 0, "", REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &IconKey, &EmptyData) == ERROR_SUCCESS)
    {
      char IconLocation[300];
      sprintf(IconLocation, "%s\\midiplay.exe,%d", ProgDir, iconnum);

      if (RegSetValueEx(IconKey, "", 0, REG_SZ, (BYTE *)IconLocation, strlen(IconLocation) + 1) != ERROR_SUCCESS)
        MessageBox(hwnd, "Error: Could not set registry data", AppName, MB_OK);

      RegCloseKey(IconKey);
    }
    else
      MessageBox(hwnd, "Error: Could not create key", AppName, MB_OK);

    HKEY ShellKey;
    if (RegCreateKeyEx(TypeKey, "shell", 0, "", REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &ShellKey, &EmptyData) == ERROR_SUCCESS)
    {
      if (RegSetValueEx(ShellKey, "", 0, REG_SZ, (BYTE *)"open", strlen("open") + 1) != ERROR_SUCCESS)
        MessageBox(hwnd, "Error: Could not set registry data", AppName, MB_OK);

      HKEY OpenKey;
      if (RegCreateKeyEx(ShellKey, "open", 0, "", REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &OpenKey, &EmptyData) == ERROR_SUCCESS)
      {
        HKEY CommandKey;
        if (RegCreateKeyEx(OpenKey, "command", 0, "", REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &CommandKey, &EmptyData) == ERROR_SUCCESS)
        {
          char OpenLocation[300];
          sprintf(OpenLocation, "%s\\midiplay.exe -midi %%1", ProgDir);

          if (RegSetValueEx(CommandKey, "", 0, REG_SZ, (BYTE *)OpenLocation, strlen(OpenLocation) + 1) != ERROR_SUCCESS)
            MessageBox(hwnd, "Error: Could not set registry data", AppName, MB_OK);

          RegCloseKey(CommandKey);
        }
        else
          MessageBox(hwnd, "Error: Could not create key", AppName, MB_OK);

        RegCloseKey(OpenKey);
      }
      else
        MessageBox(hwnd, "Error: Could not create key", AppName, MB_OK);

      RegCloseKey(ShellKey);
    }
    else
      MessageBox(hwnd, "Error: Could not create key", AppName, MB_OK);

    RegCloseKey(TypeKey);
  }
  else
    MessageBox(hwnd, "Error: Could not open registry key", AppName, MB_OK);
}


void RegisterPlaylistType(HWND hwnd, char *name, int iconnum)
{
  DWORD EmptyData;

  HKEY TypeKey;
  if (RegCreateKeyEx(HKEY_CLASSES_ROOT, name, 0, "", REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &TypeKey, &EmptyData) == ERROR_SUCCESS)
  {
    if (RegSetValueEx(TypeKey, "", 0, REG_SZ, (BYTE *)"MIDI Playlist", strlen("MIDI Playlist") + 1) != ERROR_SUCCESS)
      MessageBox(hwnd, "Error: Could not set registry data", AppName, MB_OK);

    HKEY IconKey;
    if (RegCreateKeyEx(TypeKey, "DefaultIcon", 0, "", REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &IconKey, &EmptyData) == ERROR_SUCCESS)
    {
      char IconLocation[300];
      sprintf(IconLocation, "%s\\midiplay.exe,%d", ProgDir, iconnum);

      if (RegSetValueEx(IconKey, "", 0, REG_SZ, (BYTE *)IconLocation, strlen(IconLocation) + 1) != ERROR_SUCCESS)
        MessageBox(hwnd, "Error: Could not set registry data", AppName, MB_OK);

      RegCloseKey(IconKey);
    }
    else
      MessageBox(hwnd, "Error: Could not create key", AppName, MB_OK);

    HKEY ShellKey;
    if (RegCreateKeyEx(TypeKey, "shell", 0, "", REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &ShellKey, &EmptyData) == ERROR_SUCCESS)
    {
      if (RegSetValueEx(ShellKey, "", 0, REG_SZ, (BYTE *)"open", strlen("open") + 1) != ERROR_SUCCESS)
        MessageBox(hwnd, "Error: Could not set registry data", AppName, MB_OK);

      HKEY OpenKey;
      if (RegCreateKeyEx(ShellKey, "open", 0, "", REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &OpenKey, &EmptyData) == ERROR_SUCCESS)
      {
        HKEY CommandKey;
        if (RegCreateKeyEx(OpenKey, "command", 0, "", REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &CommandKey, &EmptyData) == ERROR_SUCCESS)
        {
          char OpenLocation[300];
          sprintf(OpenLocation, "%s\\midiplay.exe -playlist %%1", ProgDir);

          if (RegSetValueEx(CommandKey, "", 0, REG_SZ, (BYTE *)OpenLocation, strlen(OpenLocation) + 1) != ERROR_SUCCESS)
            MessageBox(hwnd, "Error: Could not set registry data", AppName, MB_OK);

          RegCloseKey(CommandKey);
        }
        else
          MessageBox(hwnd, "Error: Could not create key", AppName, MB_OK);

        RegCloseKey(OpenKey);
      }
      else
        MessageBox(hwnd, "Error: Could not create key", AppName, MB_OK);

      RegCloseKey(ShellKey);
    }
    else
      MessageBox(hwnd, "Error: Could not create key", AppName, MB_OK);

    RegCloseKey(TypeKey);
  }
  else
    MessageBox(hwnd, "Error: Could not open registry key", AppName, MB_OK);
}


void RegisterFileType(HWND hwnd, char *ext, char *name)
{
  DWORD EmptyData;

  HKEY ExtKey;

  if (RegCreateKeyEx(HKEY_CLASSES_ROOT, ext, 0, "", REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &ExtKey, &EmptyData) == ERROR_SUCCESS)
  {
    if (RegSetValueEx(ExtKey, "", 0, REG_SZ, (BYTE *)name, strlen(name) + 1) != ERROR_SUCCESS)
      MessageBox(hwnd, "Error: Could not set registry data", AppName, MB_OK);

    RegCloseKey(ExtKey);
  }
  else
    MessageBox(hwnd, "Error: Could not open registry key", AppName, MB_OK);
}


#pragma argsused
BOOL CALLBACK OptionsDialogProc(HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam)
{
  int checked;

  switch (msg)
  {
    case WM_INITDIALOG:
      if (PlayOnLoad)
        SendDlgItemMessage(hwnd, IDC_PLAYONLOAD, BM_SETCHECK, 1, 0);
      return 1;

    case WM_COMMAND:
      switch (wparam)
      {
        case IDOK:
          checked = SendDlgItemMessage(hwnd, IDC_PLAYONLOAD, BM_GETCHECK, 0, 0);
          if (checked) PlayOnLoad = true; else PlayOnLoad = false;

          EndDialog(hwnd, 0);
          return 0;

        case IDCANCEL: EndDialog(hwnd, 0); return 0;

        case IDC_REGISTEREXT:
          RegisterSongType(hwnd, "MidnightSong", 1);
          RegisterPlaylistType(hwnd, "MidnightPlaylist", 2);

          checked = SendDlgItemMessage(hwnd, IDC_MIDI, BM_GETCHECK, 0, 0);
          if (checked) RegisterFileType(hwnd, ".midi", "MidnightSong");
          checked = SendDlgItemMessage(hwnd, IDC_MID, BM_GETCHECK, 0, 0);
          if (checked) RegisterFileType(hwnd, ".mid", "MidnightSong");
          checked = SendDlgItemMessage(hwnd, IDC_MPL, BM_GETCHECK, 0, 0);
          if (checked) RegisterFileType(hwnd, ".mpl", "MidnightPlaylist");
      }
      return 0;

    default: return 0;
  }
}